## kretro-0.0.1.tar.xz

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Seshan Ravikumar <seshan@sineware.ca>
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

project(kretro VERSION 0.1)

include(FeatureSummary)

set(QT_MIN_VERSION 6.6)
set(KF_MIN_VERSION 6.0.0)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMPoQmTools)
include(ECMQmlModule)

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KRETRO
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/src/version-kretro.h"
)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS Widgets Core Quick Gui Qml QuickControls2 Svg Multimedia)
find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS Kirigami CoreAddons Config I18n)
find_package(SDL3 REQUIRED) # SDL3 is used for input handling


qt_policy(SET QTP0004 NEW)

find_package(KF6KirigamiAddons 1.0.0 REQUIRED)
set_package_properties(KF6KirigamiAddons PROPERTIES
    TYPE REQUIRED
    PURPOSE "Provides additional visual components"
)

if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()

add_subdirectory(src)

install(PROGRAMS org.kde.kretro.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES org.kde.kretro.metainfo.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES org.kde.kretro.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: 2023 Seshan Ravikumar <seshan@sineware.ca>

set_source_files_properties(dbus/org.sigxcpu.Feedback.Haptic.xml PROPERTIES INCLUDE vibrationevent.h)
qt_add_dbus_interfaces(dbusinterface_SRCS
    dbus/org.sigxcpu.Feedback.Haptic.xml)

add_executable(kretro
    main.cpp
    app.cpp
    retroframe.cpp
    retrogamemodel.cpp
    retrogamesavemodel.cpp
    retropad.cpp
    objects/retrogame.cpp
    idleinhibit.cpp
    vibration.cpp
    resources.qrc
    ${dbusinterface_SRCS}
)


ecm_add_qml_module(kretro
    GENERATE_PLUGIN_SOURCE
    OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/src/org/kde/kretro # Shuts up an annoying upstream Qt warning
    URI org.kde.kretro
)

qt_target_qml_sources(kretro
    QML_FILES
        qml/Main.qml
        qml/MobileController.qml
        qml/MobilePlayer.qml
        qml/SaveManager.qml
        qml/Settings.qml
        qml/SettingsRetroCore.qml
        qml/SettingsRetroPad.qml
        qml/Help.qml

        qml/components/PageContainer.qml
        qml/components/PageHeader.qml
        qml/components/PageStack.qml
)

target_link_libraries(kretro PUBLIC
    Qt6::Core
    Qt6::Qml
    Qt6::Gui
    Qt6::QuickControls2
    Qt6::Widgets
    Qt6::Multimedia
    Qt6::DBus
    KF6::Kirigami
    KF6::I18n
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::ConfigGui
    SDL3::SDL3
)

if (ANDROID)
    kirigami_package_breeze_icons(ICONS
        list-add
        help-about
        application-exit
        applications-graphics
    )
endif()

kconfig_add_kcfg_files(kretro GENERATE_MOC kretroconfig.kcfgc)
install(TARGETS kretro ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== APKBUILD ===
# SPDX-FileCopyrightText: 2025 Seshan Ravikumar <seshan@sineware.ca>
# SPDX-License-Identifier: BSD-3-Clause

pkgname=kretro
pkgver=1.0.0_git
pkgrel=2
pkgdesc="Libretro frontend for Plasma"
arch="all !ppc64le !s390x !armhf !riscv64"
url="https://invent.kde.org/games/kretro.git"
license="GPL-2.0"
depends="
	kirigami
	kirigami-addons
	sdl3
	"
makedepends="
    extra-cmake-modules
	kconfig-dev
	ki18n-dev
	kirigami-addons-dev
	kirigami-dev
	qt6-qtbase-dev
	qt6-qtmultimedia-dev
	qt6-qtsvg-dev
	samurai
    sdl3-dev
	"
source="https://invent.kde.org/games/kretro.git"
options="!check"

build() {
    cmake -B $builddir -G Ninja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_PREFIX=/usr
	cmake --build $builddir
}

package() {
    DESTDIR="$pkgdir" cmake --install build

}
